#
# Created on Tue Mar 21 2023
#
# Copyright (c) 2023 Gddi
#

from configparser import ConfigParser

from data_client.utils import const

from .config_file import get_file_abs_path

config = ConfigParser()
config.read(get_file_abs_path(const.CONFIG_FILE), encoding='UTF-8')

def save_config(config: ConfigParser):
    """write the config to config file

    Args:
        config (ConfigParser): current config data
    """
    with open(get_file_abs_path(const.CONFIG_FILE), mode='w', encoding='UTF-8') as config_file:
        config.write(config_file)

def update_config(aifs_ip = None, aifs_port = None, s3_bucket_name = None, s3_ak = None, s3_sk = None, s3_endpoint = None, s3_region = None):
    if aifs_ip is not None:
        config["aifs"]["ip"] = aifs_ip
    if aifs_port is not None:
        config["aifs"]["port"] = aifs_port
    if s3_bucket_name is not None:
        config["s3"]["bucket_name"] = s3_bucket_name
    if s3_ak is not None:
        config["s3"]["ak"] = s3_ak
    if s3_sk is not None:
        config["s3"]["sk"] = s3_sk
    if s3_endpoint is not None:
        config["s3"]["endpoint"] = s3_endpoint
    if s3_region is not None:
        config["s3"]["region"] = s3_region
