#
# Created on Wed Mar 15 2023
#
# Copyright (c) 2023 Gddi
#

import random
import sys
import time
import unittest

from loguru import logger

from data_client.model import model
from data_client.model.model_params import ModelConfig
from data_client.utils import const


class TestModel(unittest.TestCase):
    """dataset unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    @unittest.skip("reason for skipping")
    def testSaveModelData(self):
        logger.remove()
        logger.add(sys.stderr, level="DEBUG")
        
        model_config_1 = ModelConfig(
            model_dir='/Users/lvyubin/work/data-client-work-dir/model',
            data_view_id='eeed2ea5-72d3-40a8-a286-44cbe22a0948'
        )
        model_config_2 = ModelConfig(
            model_dir='/Users/lvyubin/work/data-client-work-dir/model2',
            data_view_id='2897d7de-3d1e-446c-92e5-64f7c74d7afa'
        )
        model1, model2 = model.init([model_config_1, model_config_2])
        model1.upload_model_data(const.BEST_PTH, 'aaa.pth')
        model1.upload_model_data(const.LAST_PTH, 'bbb.pth')
        model2.upload_model_data(const.BEST_PTH, 'bbb.pth')
        model2.upload_model_data(const.LOGS)
        
        time.sleep(2)
        # no such file
        model1.upload_model_data(const.BEST_PTH, 'xxxx.pth')
        time.sleep(2)
        # remove job and add a new one
        model1.upload_model_data(const.BEST_PTH, 'aaa.pth')
        
        time.sleep(10)    
        model.finish()
    
    @unittest.skip("reason for skipping")
    def testModelProgress(self):
        logger.remove()
        logger.add(sys.stderr, level="DEBUG")
        
        model_config_1 = ModelConfig(
            model_dir='/Users/lvyubin/work/data-client-work-dir/model',
            data_view_id='eeed2ea5-72d3-40a8-a286-44cbe22a0948'
        )
        model_config_2 = ModelConfig(
            model_dir='/Users/lvyubin/work/data-client-work-dir/model2',
            data_view_id='2897d7de-3d1e-446c-92e5-64f7c74d7afa'
        )
        model1, model2 = model.init([model_config_1, model_config_2])
        
        start_time = time.time()
        while True:
            time.sleep(3)
            print(model.get_progress())
            new_progress = float(random.randint(1,99))
            print(f'new progress {new_progress}')
            model.update_progress(new_progress)
            if time.time() - start_time > 30:
                break
        model.finish()
    
    @unittest.skip("reason for skipping")
    def testModelPull(self):
        logger.remove()
        logger.add(sys.stderr, level="DEBUG")
        
        model_config_1 = ModelConfig(
            model_dir='/Users/lvyubin/work/data-client-work-dir/model4',
            data_view_id='eeed2ea5-72d3-40a8-a286-44cbe22a0948',
        )
        model_config_2 = ModelConfig(
            model_dir='/Users/lvyubin/work/data-client-work-dir/model3',
            data_view_id='2897d7de-3d1e-446c-92e5-64f7c74d7afa',
        )
        model1, model2 = model.init([model_config_1, model_config_2])
        
        model1.pull(model_file_list = [const.LOGS, const.ONNX, const.BEST_PTH, const.LAST_PTH])
        model2.pull(model_file_list = [const.LOGS, const.ONNX, const.BEST_PTH, const.LAST_PTH])
        
        time.sleep(3)
        model.finish()

    
    @unittest.skip("reason for skipping")
    def testIsCompleted(self):
        logger.remove()
        logger.add(sys.stderr, level="DEBUG")
        
        model_config_1 = ModelConfig(
            model_dir='/Users/lvyubin/work/data-client-work-dir/model4',
            data_view_id='eeed2ea5-72d3-40a8-a286-44cbe22a0948'        
        )
        model_config_2 = ModelConfig(
            model_dir='/Users/lvyubin/work/data-client-work-dir/model3',
            data_view_id='2897d7de-3d1e-446c-92e5-64f7c74d7afa'
        )
        model1, model2 = model.init([model_config_1, model_config_2])
        
        model.update_progress(100.0)
        time.sleep(3)
        self.assertTrue(model.is_completed())
        model.finish()
        
  
if __name__ == '__main__':
    unittest.main()
